
/**
 * Title:        "Knowledge Emerging from Behaviour" Architecture<p>
 * Description:  <p>
 * Copyright:    Copyright (c) Carlos Gershenson, C.Gershenson@sussex.ac.uk<p>
 * Company:      COGS, University of Sussex<p>
 * @author Carlos Gershenson, C.Gershenson@sussex.ac.uk
 * @version 3.0
 */
package keba;

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import javax.swing.border.*;
import javax.vecmath.*;
import keba.tools.Tools;

public abstract class AnimatFrame extends JFrame {//GUI of Animats
  Animat as;//abstract animat, to be used in AnimatFrame functions, but same as child
  TextArea output;
  FlowLayout flowLayout1 = new FlowLayout();
  JToggleButton verboseTB = new JToggleButton();
  JToggleButton trailTB = new JToggleButton();
  JButton rmTrailB = new JButton();
  JButton clearB = new JButton();
  JTextField nameTF = new JTextField();
  JButton nameB = new JButton();
  JLabel nameL = new JLabel();
  JLabel zL = new JLabel();
  JTextField zTF = new JTextField();
  JLabel xL = new JLabel();
  JTextField xTF = new JTextField();
  JLabel radiusL = new JLabel();
  JTextField radiusTF = new JTextField();
  JLabel angleL = new JLabel();
  JTextField angleTF = new JTextField();
  JButton coordsB = new JButton();
  JPanel coordsP = new JPanel();
  Border border1;
  TitledBorder titledBorder1;
  FlowLayout flowLayout2 = new FlowLayout();
  JButton removeB = new JButton();
  JLabel noiseL = new JLabel();
  JTextField noiseTF = new JTextField();
  JButton noiseB = new JButton();
  JLabel rpL = new JLabel();
  JTextField rpTF = new JTextField();
  JButton rpB = new JButton();
  JPanel percP = new JPanel();
  Border border2;
  TitledBorder titledBorder2;
  FlowLayout flowLayout3 = new FlowLayout();
  JPanel jPanel1 = new JPanel();
  FlowLayout flowLayout4 = new FlowLayout();
  JToggleButton immortalTB = new JToggleButton();
  JPanel internalP = new JPanel();
  TitledBorder titledBorder3;
  FlowLayout flowLayout5 = new FlowLayout();
  JSlider hungerS = new JSlider();
  JSlider thirstS = new JSlider();
  JSlider energyS = new JSlider();
  JLabel hungerL = new JLabel();
  JLabel thirstL = new JLabel();
  JLabel energyL = new JLabel();

  public AnimatFrame(Animat na) {//children classes should just call super constructor...
    try {
      jbInit(na);
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }

  abstract void jbInit(Animat na) throws Exception;

  void jbInitAll() throws Exception {
    this.setResizable(false);
    this.setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
    this.getContentPane().setLayout(flowLayout1);

    border2 = BorderFactory.createBevelBorder(BevelBorder.RAISED,Color.white,Color.white,new Color(142, 142, 142),new Color(99, 99, 99));
    titledBorder2 = new TitledBorder(border2,"Perceptions",
        TitledBorder.DEFAULT_JUSTIFICATION,TitledBorder.DEFAULT_POSITION,
        new java.awt.Font("Dialog", 0, 10),Color.darkGray);
    this.setTitle(KEBA.phType(as.type)+" "+as.name);
    border1 = BorderFactory.createBevelBorder(BevelBorder.RAISED,Color.white,Color.white,new Color(142, 142, 142),new Color(99, 99, 99));
    titledBorder1 = new TitledBorder(border1,"Coordinates",
        TitledBorder.DEFAULT_JUSTIFICATION,TitledBorder.DEFAULT_POSITION,
        new java.awt.Font("Dialog", 0, 10),Color.darkGray);
    titledBorder3 = new TitledBorder(border1,"Internal States",
        TitledBorder.DEFAULT_JUSTIFICATION,TitledBorder.DEFAULT_POSITION,
        new java.awt.Font("Dialog", 0, 10),Color.darkGray);

    verboseTB.setMargin(new Insets(0, 4, 0, 4));
    verboseTB.setToolTipText("Show detailed information");
    verboseTB.setText("Verbose");
    verboseTB.setFont(new java.awt.Font("Dialog", 1, 10));
    verboseTB.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        verboseTB_actionPerformed(e);
      }
    });
    trailTB.setMargin(new Insets(0, 4, 0, 4));
    trailTB.setToolTipText("Leave trail");
    trailTB.setText("Trail");
    trailTB.setFont(new java.awt.Font("Dialog", 1, 10));
    trailTB.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        trailTB_actionPerformed(e);
      }
    });
    rmTrailB.setFont(new java.awt.Font("Dialog", 1, 10));
    rmTrailB.setToolTipText("Remove trail");
    rmTrailB.setMargin(new Insets(0, 4, 0, 4));
    rmTrailB.setText("Remove");
    rmTrailB.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        rmTrailB_actionPerformed(e);
      }
    });
    clearB.setFont(new java.awt.Font("Dialog", 1, 10));
    clearB.setToolTipText("Clear output");
    clearB.setMargin(new Insets(0, 4, 0, 4));
    clearB.setText("Clear");
    clearB.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        clearB_actionPerformed(e);
      }
    });
    nameTF.setFont(new java.awt.Font("Dialog", 0, 10));
    nameTF.setPreferredSize(new Dimension(50, 19));
    nameTF.setToolTipText("Enter new Animat name");
    nameTF.setText(as.name);
    nameB.setFont(new java.awt.Font("Dialog", 1, 10));
    nameB.setToolTipText("Set name for animat");
    nameB.setMargin(new Insets(0, 4, 0, 4));
    nameB.setText("Set");
    nameB.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        nameB_actionPerformed(e);
      }
    });
    nameL.setFont(new java.awt.Font("Dialog", 1, 10));
    nameL.setText("Name:");
    zL.setFont(new java.awt.Font("Dialog", 1, 10));
    zL.setText("Z:");
    zTF.setFont(new java.awt.Font("Dialog", 0, 10));
    zTF.setPreferredSize(new Dimension(30, 19));
    zTF.setToolTipText("");
    zTF.setText(Tools.str(as.z));
    xL.setFont(new java.awt.Font("Dialog", 1, 10));
    xL.setText("X:");
    xTF.setFont(new java.awt.Font("Dialog", 0, 10));
    xTF.setPreferredSize(new Dimension(30, 19));
    xTF.setText(Tools.str(as.x));
    radiusL.setFont(new java.awt.Font("Dialog", 1, 10));
    radiusL.setText("radius:");
    radiusTF.setFont(new java.awt.Font("Dialog", 0, 10));
    radiusTF.setPreferredSize(new Dimension(25, 19));
    radiusTF.setText(Tools.str(as.radius));
    angleL.setFont(new java.awt.Font("Dialog", 1, 10));
    angleL.setToolTipText("(in radians)");
    angleL.setText("Angle:");
    angleTF.setFont(new java.awt.Font("Dialog", 0, 10));
    angleTF.setPreferredSize(new Dimension(30, 19));
    angleTF.setToolTipText("(in radians)");
    angleTF.setText(Tools.str(as.th));
    coordsB.setFont(new java.awt.Font("Dialog", 1, 10));
    coordsB.setToolTipText("Set Coordinates");
    coordsB.setMargin(new Insets(0, 4, 0, 4));
    coordsB.setText("Set");
    coordsB.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        coordsB_actionPerformed(e);
      }
    });
    coordsP.setBackground(SystemColor.inactiveCaptionText);
    coordsP.setFont(new java.awt.Font("Dialog", 0, 10));
    coordsP.setBorder(titledBorder1);
    coordsP.setPreferredSize(new Dimension(290, 60));
    coordsP.setLayout(flowLayout2);
    removeB.setFont(new java.awt.Font("Dialog", 1, 10));
    removeB.setToolTipText("Remove animat from environment");
    removeB.setMargin(new Insets(0, 4, 0, 4));
    removeB.setText("Remove animat");
    removeB.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        removeB_actionPerformed(e);
      }
    });
    noiseL.setFont(new java.awt.Font("Dialog", 1, 10));
    noiseL.setText("Noise:");
    noiseTF.setFont(new java.awt.Font("Dialog", 0, 10));
    noiseTF.setToolTipText("Noise added to sensors");
    noiseTF.setText(Tools.str(as.noise));
    noiseTF.setPreferredSize(new Dimension(30, 19));
    noiseB.setFont(new java.awt.Font("Dialog", 1, 10));
    noiseB.setToolTipText("Set noise for perception");
    noiseB.setMargin(new Insets(0, 4, 0, 4));
    noiseB.setText("Set");
    noiseB.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        noiseB_actionPerformed(e);
      }
    });
    rpL.setFont(new java.awt.Font("Dialog", 1, 10));
    rpL.setText("Rp:");
    rpTF.setFont(new java.awt.Font("Dialog", 0, 10));
    rpTF.setToolTipText("Radius of perception (for sight, hearing, and smell)");
    rpTF.setText(Tools.str(as.rp));
    rpTF.setPreferredSize(new Dimension(30, 19));
    rpB.setFont(new java.awt.Font("Dialog", 1, 10));
    rpB.setToolTipText("Set radius of perception");
    rpB.setMargin(new Insets(0, 4, 0, 4));
    rpB.setText("Set");
    rpB.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        rpB_actionPerformed(e);
      }
    });
    percP.setBackground(SystemColor.inactiveCaptionText);
    percP.setFont(new java.awt.Font("Dialog", 0, 10));
    percP.setBorder(titledBorder2);
    percP.setPreferredSize(new Dimension(290, 60));
    percP.setLayout(flowLayout3);
    jPanel1.setBackground(SystemColor.inactiveCaptionText);
    jPanel1.setMinimumSize(new Dimension(372, 100));
    jPanel1.setPreferredSize(new Dimension(300, 120));
    jPanel1.setLayout(flowLayout4);

    immortalTB.setMargin(new Insets(0, 4, 0, 4));
    immortalTB.setToolTipText("Set animat to be immortal");
    immortalTB.setText("Immortal");
    immortalTB.setActionCommand("immortalTB");
    immortalTB.setFont(new java.awt.Font("Dialog", 1, 10));
    immortalTB.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        immortalTB_actionPerformed(e);
      }
    });
    internalP.setBackground(SystemColor.inactiveCaptionText);
    internalP.setBorder(titledBorder3);
    internalP.setPreferredSize(new Dimension(110, 100));
    internalP.setLayout(flowLayout5);
    hungerS.setPreferredSize(new Dimension(50, 16));
    hungerS.setBackground(Color.green);
    hungerS.setValue((int)Math.round(as.hunger*100));
    hungerS.setToolTipText("Animat's hunger");
    hungerS.addMouseListener(new java.awt.event.MouseAdapter() {
      public void mouseReleased(MouseEvent e) {
        hungerS_ev(e);
      }
    });
    hungerS.addKeyListener(new java.awt.event.KeyAdapter() {
      public void keyReleased(KeyEvent e) {
        hungerS_ev(e);
      }
    });
    thirstS.setPreferredSize(new Dimension(50, 16));
    thirstS.setBackground(Color.blue);
    thirstS.setValue((int)Math.round(as.thirst*100));
    thirstS.setToolTipText("Animat's thirst");
    thirstS.addMouseListener(new java.awt.event.MouseAdapter() {
      public void mouseReleased(MouseEvent e) {
        thirstS_ev(e);
      }
    });
    thirstS.addKeyListener(new java.awt.event.KeyAdapter() {
      public void keyReleased(KeyEvent e) {
        thirstS_ev(e);
      }
    });
    energyS.setPreferredSize(new Dimension(50, 16));
    energyS.setBackground(Color.red);
    energyS.setValue((int)Math.round(as.energy*100));
    energyS.setToolTipText("Animat's energy");
    energyS.addMouseListener(new java.awt.event.MouseAdapter() {
      public void mouseReleased(MouseEvent e) {
        energyS_ev(e);
      }
    });
    energyS.addKeyListener(new java.awt.event.KeyAdapter() {
      public void keyReleased(KeyEvent e) {
        energyS_ev(e);
      }
    });
    hungerL.setFont(new java.awt.Font("Dialog", 1, 10));
    hungerL.setForeground(Color.green);
    hungerL.setText("Hunger");
    thirstL.setText(" Thirst  ");
    thirstL.setFont(new java.awt.Font("Dialog", 1, 10));
    thirstL.setForeground(Color.blue);
    energyL.setText("Energy");
    energyL.setBounds(new Rectangle(-19, 0, 34, 15));
    energyL.setFont(new java.awt.Font("Dialog", 1, 10));
    energyL.setForeground(Color.red);
    flowLayout5.setAlignment(FlowLayout.RIGHT);
    flowLayout4.setHgap(0);
    flowLayout4.setVgap(0);

    jPanel1.add(coordsP, null);
    internalP.add(energyL, null);
    internalP.add(energyS, null);
    internalP.add(thirstL, null);
    internalP.add(thirstS, null);
    internalP.add(hungerL, null);
    internalP.add(hungerS, null);
    coordsP.add(zL, null);
    coordsP.add(zTF, null);
    coordsP.add(xL, null);
    coordsP.add(xTF, null);
    coordsP.add(radiusL, null);
    coordsP.add(radiusTF, null);
    coordsP.add(angleL, null);
    coordsP.add(angleTF, null);
    coordsP.add(coordsB, null);
    jPanel1.add(percP, null);
    percP.add(noiseL, null);
    percP.add(noiseTF, null);
    percP.add(noiseB, null);
    percP.add(rpL, null);
    percP.add(rpTF, null);
    percP.add(rpB, null);

    if (as.verbose){
      verboseTB.setSelected(true);
    }
    if (as.leaveTrail){
      trailTB.setSelected(true);
      as.iniTrail();
    }
    if (as.immortal){
      immortalTB.setSelected(true);
    }

  }

  abstract void step();// (implement stepState() at the end...)

  void stepState() {//for all animats
    hungerS.setValue((int)Math.round(as.hunger*100));
    thirstS.setValue((int)Math.round(as.thirst*100));
    energyS.setValue((int)Math.round(as.energy*100));
    if (as.verbose){
      zTF.setText(Tools.str(as.z,5));
      xTF.setText(Tools.str(as.x,5));
      radiusTF.setText(Tools.str(as.radius,5));
      angleTF.setText(Tools.str(as.th,5));
      output.append(as.msg);
      if((output.getText().length()+as.msg.length())>30000){
        if (as.msg.length()<10000)
          output.setText(output.getText().substring(output.getText().length()-as.msg.length(),output.getText().length()));
        else
          output.setText(as.msg.substring(0,4900)+"\n\n  ...\n\n"+
                         as.msg.substring(as.msg.length()-5000,as.msg.length()));
      }
    }
    if (as.dead){
       output.append("ANIMAT DIED!!! Requiescat In Pace...\n");
       output.append("  lived for : "+Tools.str(as.time)+" time steps...\n");
    }
  }

  void verboseTB_actionPerformed(ActionEvent e) {
    if(as.verbose)
      output.append("OK, I'll shut up.\n");
    else
      output.append("Information just for you!\n");
    as.verbose =! as.verbose;
  }

  void trailTB_actionPerformed(ActionEvent e) {
    if(as.leaveTrail)
      output.append("No more trail.\n");
    else{
      output.append("Leave trail.\n");
      as.iniTrail();
    }
    as.leaveTrail =! as.leaveTrail;
  }

  void rmTrailB_actionPerformed(ActionEvent e) {
    if (as.verbose) output.append("Removing trail...");
    as.removeTrail();
    if (as.verbose) output.append(" done!\n");
  }

  void clearB_actionPerformed(ActionEvent e) {
    output.setText("Nice and clean...\n");
  }

  void nameB_actionPerformed(ActionEvent e) {
    String prev=as.name;
    as.name=nameTF.getText();
    output.append("Animat "+prev+" is now known as "+as.name+"\n");
    this.setTitle(KEBA.phType(as.type)+" "+as.name);
  }

  void coordsB_actionPerformed(ActionEvent e) {
    boolean ok=true;
    float zprov = 0,xprov = 0,rprov=1,thprov = 0;
    try {
      zprov = Float.valueOf(zTF.getText()).floatValue();
      xprov = Float.valueOf(xTF.getText()).floatValue();
      rprov = Float.valueOf(radiusTF.getText()).floatValue();
      thprov = Float.valueOf(angleTF.getText()).floatValue();
    }
    catch (NumberFormatException nfe) {
      output.append("Please fill the Coordinates fields correctly!\n");
      ok = false;
    }
    if (ok) {
      as.z=zprov;
      as.x=xprov;
      as.z2=as.z;
      as.x2=as.x;
      as.radius=rprov;
      as.th=thprov;
      as.t.rotY(as.th);
      as.t.setTranslation(new Vector3f(as.x,1+(0.5f*as.radius),as.z));
      as.t.setScale(new Vector3d(as.radius,as.radius,as.radius));
      as.tg.setTransform(as.t);
      if (as.verbose)
        output.append("New animat position: "+Tools.str(as.z)+", "
            +Tools.str(as.x)+", new radius: "+Tools.str(as.radius)
            +", new angle: "+Tools.str(as.th)+"\n");
    }
  }

  void removeB_actionPerformed(ActionEvent e) {
    output.append("Goodbye, cruel virtual world...\n");
    KEBA.removeAnimat(as);
    as.destroy();
    this.dispose();
  }

  void noiseB_actionPerformed(ActionEvent e) {
    boolean ok=true;
    float nprov = 0;
    try {
      nprov = Float.valueOf(noiseTF.getText()).floatValue();
    }
    catch (NumberFormatException nfe) {
      output.append("Please fill the Noise field correctly!\n");
      ok = false;
    }
    if (ok) {
      as.noise=nprov;
      if (as.verbose)
        output.append("Noise for perception set at: "+Tools.str(as.noise)+"\n");
    }
  }
  void rpB_actionPerformed(ActionEvent e) {
    boolean ok=true;
    float rpprov = 0;
    try {
      rpprov = Float.valueOf(rpTF.getText()).floatValue();
    }
    catch (NumberFormatException nfe) {
      output.append("Please fill the Rp field correctly!\n");
      ok = false;
    }
    if (ok) {
      as.rp=rpprov;
      if (as.verbose)
        output.append("New radius of perception: "+Tools.str(as.rp)+"\n");
    }
  }

  void immortalTB_actionPerformed(ActionEvent e) {
    if(as.immortal)
      output.append("Mortal again...\n");
    else
      output.append("Animat is immortal!\n");
    as.immortal =! as.immortal;
  }

  void energyS_ev(MouseEvent e) {
    energyS_ev();
  }
  void energyS_ev(KeyEvent e) {
    energyS_ev();
  }
  void energyS_ev() {
    float tmp=energyS.getValue();
    as.energy=tmp/100;
    if (as.verbose)
      output.append("New energy value = "+Tools.str(as.energy,5)+"\n");
  }

  void thirstS_ev(MouseEvent e) {
    thirstS_ev();
  }
  void thirstS_ev(KeyEvent e) {
    thirstS_ev();
  }
  void thirstS_ev() {
    float tmp=thirstS.getValue();
    as.thirst=tmp/100;
    if (as.verbose)
      output.append("New thirst value = "+Tools.str(as.thirst,5)+"\n");
  }

  void hungerS_ev(MouseEvent e) {
    hungerS_ev();
  }
  void hungerS_ev(KeyEvent e) {
    hungerS_ev();
  }
  void hungerS_ev() {
    float tmp=hungerS.getValue();
    as.hunger=tmp/100;
    if (as.verbose)
      output.append("New hunger value = "+Tools.str(as.hunger,5)+"\n");
  }

}