
/**
 * Title:        "Knowledge Emerging from Behaviour" Architecture<p>
 * Description:  <p>
 * Copyright:    Copyright (c) Carlos Gershenson, C.Gershenson@sussex.ac.uk<p>
 * Company:      COGS, University of Sussex<p>
 * @author Carlos Gershenson, C.Gershenson@sussex.ac.uk
 * @version 3.0
 */
package keba;

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import javax.swing.border.*;
import javax.vecmath.*;
import keba.tools.Tools;

public class AnimatMaesFrame extends AnimatFrame {
  AnimatMaes a;
  JLabel paramL;
  JComboBox paramCB;
  JTextField paramTF;
  JButton paramB;

  public AnimatMaesFrame(Animat na) {
    super(na);
  }

  void jbInit(Animat na) throws Exception {
    a=(AnimatMaes)na;
    as=(Animat)a;
    paramL = new JLabel();
    paramCB = new JComboBox();
    paramTF = new JTextField();
    paramB = new JButton();

    jbInitAll();

    this.setBounds(60,110,430,490);

    output = new TextArea(21, 68);
    output.setFont(new java.awt.Font("Monospaced", 0, 10));
    paramL.setFont(new java.awt.Font("Dialog", 1, 10));
    paramL.setText("Parameter:");
    paramCB.setFont(new java.awt.Font("Dialog", 1, 10));
    paramCB.setToolTipText("Select parameter");
    paramCB.addItem("theta");
    paramCB.addItem("phi");
    paramCB.addItem("gamma");
    paramCB.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        paramCB_actionPerformed(e);
      }
    });
    paramTF.setFont(new java.awt.Font("Dialog", 0, 10));
    paramTF.setToolTipText("Insert parameters");
    paramTF.setText(Tools.str(a.theta));
    paramTF.setPreferredSize(new Dimension(30, 19));
    paramB.setFont(new java.awt.Font("Dialog", 1, 10));
    paramB.setToolTipText("Set parameter");
    paramB.setMargin(new Insets(0, 4, 0, 4));
    paramB.setText("Set");
    paramB.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        paramB_actionPerformed(e);
      }
    });


    this.getContentPane().add(output, null);
    this.getContentPane().add(nameL, null);
    this.getContentPane().add(nameTF, null);
    this.getContentPane().add(nameB, null);
    this.getContentPane().add(clearB, null);
    this.getContentPane().add(verboseTB, null);
    this.getContentPane().add(immortalTB, null);
    this.getContentPane().add(trailTB, null);
    this.getContentPane().add(rmTrailB, null);
    this.getContentPane().add(jPanel1, null);
    this.getContentPane().add(internalP, null);
    this.getContentPane().add(paramL, null);
    this.getContentPane().add(paramCB, null);
    this.getContentPane().add(paramTF, null);
    this.getContentPane().add(paramB, null);
    this.getContentPane().add(new JLabel("   "), null);
    this.getContentPane().add(removeB, null);

    this.show();
  }

  public void step(){
    stepState();
  }

  void paramB_actionPerformed(ActionEvent e) {
    boolean ok=true;
    float prov = 0;
    try {
      prov = Float.valueOf(paramTF.getText()).floatValue();
    }
    catch (NumberFormatException nfe) {
      output.append("Please fill the parameter field correctly!\n");
      ok = false;
    }
    if (ok) {
      switch(paramCB.getSelectedIndex()){
        case 0://theta
          a.theta=prov;
          if (a.verbose)
            output.append("New theta (activation threshold): "+Tools.str(a.theta)+"\n");
        break;
        case 1://phi
          a.phi=prov;
          if (a.verbose)
            output.append("New phi (reactivity): "+Tools.str(a.phi)+"\n");
        break;
        case 2://gamma
          a.gamma=prov;
          if (a.verbose)
            output.append("New gamma (motivation): "+Tools.str(a.gamma)+"\n");
        break;
      }
    }
  }

  void paramCB_actionPerformed(ActionEvent e) {
    switch(paramCB.getSelectedIndex()){
      case 0:
        paramTF.setText(Tools.str(a.theta));
      break;
      case 1:
        paramTF.setText(Tools.str(a.phi));
      break;
      case 2:
        paramTF.setText(Tools.str(a.gamma));
      break;
    }
  }

}