
/**
 * Title:        "Knowledge Emerging from Behaviour" Architecture<p>
 * Description:  <p>
 * Copyright:    Copyright (c) Carlos Gershenson, C.Gershenson@sussex.ac.uk<p>
 * Company:      COGS, University of Sussex<p>
 * @author Carlos Gershenson, C.Gershenson@sussex.ac.uk
 * @version 3.0
 */
package keba;

import javax.media.j3d.*;
import javax.vecmath.*;
import com.sun.j3d.utils.geometry.*;
import keba.tools.*;
import java.awt.Color;

public class Food extends Phenomenon {

  public Food(float nz, float nx, float nradius, long nid) {
    //z x radius colour flavourp flavourn odourp odourn hardness loudness id type
    super(nz,nx,nradius,new Color(0.0f, 0.7f, 0.1f),0.9f,0.0f,0.8f,0.0f,0.3f,0.0f,
          nid,KEBA.FOOD);
    init3D();
  }

  void init3D(){
    t=new STransform3D();
    t.setTranslation(new Vector3f(x,1+radius,z));
    tg.setTransform(t);
    TexturedAppearance tapp=new TexturedAppearance("keba/img/moss.jpg");
    Color3f aColor    = new Color3f(0.0f, 0.8f, 0.1f);
    Color3f eColor    = new Color3f(0.0f, 0.9f, 0.0f);
    Color3f dColor    = new Color3f(colour);
    Color3f sColor    = new Color3f(0.2f, 0.9f, 0.3f);
    Material mat = new Material(aColor, eColor, dColor, sColor, 100.0f);
    mat.setLightingEnable(true);
    tapp.setMaterial(mat);
    tg.addChild(new Sphere(radius,Primitive.GENERATE_NORMALS
                           | Primitive.GENERATE_TEXTURE_COORDS,tapp));
  }

  void step() {
    time++;
    //change colour, odour, flavour, size...???
    if (time>=5000){//rot...
      KEBA.transform(this);
    }
  }
}