
/**
 * Title:        "Knowledge Emerging from Behaviour" Architecture<p>
 * Description:  <p>
 * Copyright:    Copyright (c) Carlos Gershenson, C.Gershenson@sussex.ac.uk<p>
 * Company:      COGS, University of Sussex<p>
 * @author Carlos Gershenson, C.Gershenson@sussex.ac.uk
 * @version 3.0
 */

package keba;

import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.Vector;
import java.util.Random;
import javax.swing.*;
import javax.swing.border.*;
import javax.media.j3d.*;
import javax.vecmath.*;
import com.sun.j3d.utils.universe.*;
import com.sun.j3d.utils.behaviors.mouse.*;
import com.sun.j3d.utils.behaviors.keyboard.*;
import com.sun.j3d.utils.geometry.*;
import com.sun.j3d.utils.image.TextureLoader;
import com.sun.j3d.utils.applet.MainFrame;
import keba.tools.*;

public class KEBA extends JFrame implements Runnable{
  public static long t; //father time...
  public static Vector phenomena;//vector of phenomena
  public static Vector phenomena2;//vector of phenomena for repeating sims
  long delay = 100;//delay in ms per simstep
  long period = 50;//period for repeating sims
  long trans = 0;//translation for repeating sims
  Thread sim = null;//Simulation thread
  public static Random rnd = new Random();
  public static long lastID=0;//need to set lastID when loading simulations!
  boolean pause;
  public static boolean verbose;
  boolean repeat;
  float rndCreatePh;
  String filename=null;
  String phenFile="phenomena.vec";
  public static Vector stats=new Vector(10,3);//vector of StatStreams
  public static StatStream ostream = null ;

  public static int envRadius;//=side of arena/2
  //constants
  public static final int TYPES_OF_ANIMAT=5;
  public static final int TYPES_OF_PHENOMENA=11+TYPES_OF_ANIMAT;
  //need to declare phenomena in ascending continuous order
  public static final int ANIMAT_RULE=0;
  public static final int ANIMAT_MAES=1;
  public static final int ANIMAT_KEBA=2;
  public static final int ANIMAT_NN=3;
  public static final int ANIMAT_BRAIT=4;
  public static final int FOOD=5;
  public static final int ROCK=6;
  public static final int RAIN=7;
  public static final int LIGHTNING=8;
  public static final int SPOT_RED=9;
  public static final int SPOT_GREEN=10;
  public static final int SPOT_BLUE=11;
  public static final int SPOT_YELLOW=12;
  public static final int SPOT_WHITE=13;
  public static final int SPOT_BLACK=14;
  public static final int SPOT_RND=15;
  //more or less each when to create phenomena randomly
  public static final int WHEN_ANIMAT=-1;//never
  public static final int WHEN_FOOD=-1;//never
  public static final int WHEN_ROCK=300;
  public static final int WHEN_RAIN=-1;//never
  public static final int WHEN_LIGHTNING=90;
  public static final int WHEN_SPOT_RED=450;
  public static final int WHEN_SPOT_GREEN=900;
  public static final int WHEN_SPOT_BLUE=300;
  public static final int WHEN_SPOT_YELLOW=1500;
  public static final int WHEN_SPOT_WHITE=999;
  public static final int WHEN_SPOT_BLACK=1222;
  public static final int WHEN_SPOT_RND=3000;

  public static final int RESET=1;
  public static final int SAVE=0;

  //java3D variables
  VirtualUniverse virtualU;
  public static BranchGroup scene;
  TransformGroup viewTrans=new TransformGroup();
  public static BoundingSphere bounds = new BoundingSphere(new Point3d(0.0,0.0,0.0), 1000.0);
  //GUI variables
  JPanel contentPane;
  public static TextArea output = new TextArea(8, 45);
  public static JLabel statusBar = new JLabel();
  JMenuBar menuBar1 = new JMenuBar();
  JMenu menuFile = new JMenu();
  JMenuItem menuFileNew = new JMenuItem();
  JMenuItem menuFileSave = new JMenuItem();
  JMenuItem menuFileSaveAs = new JMenuItem();
  JMenuItem menuFileLoad = new JMenuItem();
  JMenuItem menuFileExit = new JMenuItem();
  JMenu menuHelp = new JMenu();
  JMenuItem menuHelpAbout = new JMenuItem();
  JToolBar toolBar = new JToolBar();
  JButton bLoad = new JButton();
  JButton bSave = new JButton();
  JButton bHelp = new JButton();
  ImageIcon image1;
  ImageIcon image2;
  ImageIcon image3;
  BorderLayout borderLayout1 = new BorderLayout();
  JPanel panelControls = new JPanel();
  JButton bClear = new JButton();
  JButton bStartStop = new JButton();
  JToggleButton bVerbose = new JToggleButton();
  JComboBox viewCB = new JComboBox();
  FlowLayout flowLayout1 = new FlowLayout();
  JComboBox phenomenaCB = new JComboBox();
  JTextField zTF=new JTextField();
  JTextField xTF=new JTextField();
  JButton bCreatePhenomena=new JButton();
  JLabel xL = new JLabel();
  JLabel zL = new JLabel();
  JLabel radiusL = new JLabel();
  JTextField radiusTF = new JTextField();
  JLabel delayL = new JLabel();
  JTextField delayTF = new JTextField();
  JButton delayB = new JButton();
  JRadioButton randomPhRB = new JRadioButton();
  JPanel phenomenaPanel = new JPanel();
  Border border1;
  TitledBorder titledBorder1;
  FlowLayout flowLayout2 = new FlowLayout();
  JButton bDeletePhenomena = new JButton();
  JRadioButton ascDelRB = new JRadioButton();
  JButton bStep = new JButton();
  JRadioButton repeatRB = new JRadioButton();
  JTextField repeatTF = new JTextField();
  JSlider rndCreatePhS = new JSlider();
  JLabel rndCreatePhL = new JLabel();

  //Construct the frame
  public KEBA(int radius, int width, int height) {
    envRadius=radius;
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try {
      jbInit(width, height);
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }

  //Component initialization
  private void jbInit(int width, int height) throws Exception  {
    image1 = new ImageIcon(KEBA.class.getResource("img/openFile.gif"));
    image2 = new ImageIcon(KEBA.class.getResource("img/closeFile.gif"));
    image3 = new ImageIcon(KEBA.class.getResource("img/help.gif"));
    contentPane = (JPanel) this.getContentPane();
    border1 = BorderFactory.createBevelBorder(BevelBorder.RAISED,Color.white,Color.white,new Color(142, 142, 142),new Color(99, 99, 99));
    titledBorder1 = new TitledBorder(border1,"Phenomena",
        TitledBorder.DEFAULT_JUSTIFICATION,TitledBorder.DEFAULT_POSITION,
        new java.awt.Font("Dialog", 0, 10),Color.darkGray);

    contentPane.setLayout(borderLayout1);
    //this.setSize(new Dimension(600,400));
    //this.setSize(new Dimension(width, height));
    this.setBounds(800-width,0,width,height);
    //this.setResizable(false);
    this.setTitle("KEBA");
    statusBar.setText("Welcome to KEBA");
    menuFile.setText("File");
    menuFileNew.setText("New");
    menuFileNew.addActionListener(new ActionListener()  {
      public void actionPerformed(ActionEvent e) {
        fileNew_actionPerformed(e);
      }
    });
    menuFileSave.setText("Save");
    menuFileSave.addActionListener(new ActionListener()  {
      public void actionPerformed(ActionEvent e) {
        fileSave_actionPerformed(e);
      }
    });
    menuFileSaveAs.setText("Save As...");
    menuFileSaveAs.addActionListener(new ActionListener()  {
      public void actionPerformed(ActionEvent e) {
        fileSaveAs_actionPerformed(e);
      }
    });
    menuFileLoad.setText("Load");
    menuFileLoad.addActionListener(new ActionListener()  {
      public void actionPerformed(ActionEvent e) {
        fileLoad_actionPerformed(e);
      }
    });
    menuFileExit.setText("Exit");
    menuFileExit.addActionListener(new ActionListener()  {
      public void actionPerformed(ActionEvent e) {
        fileExit_actionPerformed(e);
      }
    });
    menuHelp.setText("Help");
    menuHelpAbout.setText("About");
    menuHelpAbout.addActionListener(new ActionListener()  {

      public void actionPerformed(ActionEvent e) {
        helpAbout_actionPerformed(e);
      }
    });
    bLoad.setIcon(image1);
    bLoad.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        bLoad_actionPerformed(e);
      }
    });
    bLoad.setToolTipText("Open File");
    bSave.setIcon(image2);
    bSave.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        bSave_actionPerformed(e);
      }
    });
    bSave.setToolTipText("Save File");
    bHelp.setIcon(image3);
    bHelp.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        bHelp_actionPerformed(e);
      }
    });
    bHelp.setToolTipText("Help");
    panelControls.setLayout(flowLayout1);
    output.setFont(new java.awt.Font("Monospaced", 0, 10));
    output.setText("Welcome to KEBA\n");
    output.setBackground(Color.white);
    panelControls.setFont(new java.awt.Font("Dialog", 0, 10));
    panelControls.setPreferredSize(new Dimension(300, 360));
    bClear.setFont(new java.awt.Font("Dialog", 1, 10));
    bClear.setToolTipText("Clear output");
    bClear.setMargin(new Insets(0, 4, 0, 4));
    bClear.setText("Clear");
    bClear.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        bClear_actionPerformed(e);
      }
    });
    bStartStop.setFont(new java.awt.Font("Dialog", 1, 10));
    bStartStop.setToolTipText("Start simulation");
    bStartStop.setMargin(new Insets(0, 4, 0, 4));
    bStartStop.setText("Start!");
    bStartStop.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        bStartStop_actionPerformed(e);
      }
    });
    bVerbose.setToolTipText("Switch ");
    bVerbose.setMargin(new Insets(0, 4, 0, 4));
    bVerbose.setToolTipText("Show detailed information");
    bVerbose.setText("Verbose");
    bVerbose.setFont(new java.awt.Font("Dialog", 1, 10));
    bVerbose.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        bVerbose_actionPerformed(e);
      }
    });
    viewCB.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        viewCB_actionPerformed(e);
      }
    });
    viewCB.addItem("Home");
    viewCB.addItem("Down");
    viewCB.addItem("Corner");
    viewCB.addItem("Top");
    viewCB.addItem("Isometric");
    viewCB.setFont(new java.awt.Font("Dialog", 1, 10));
    viewCB.setPreferredSize(new Dimension(80, 21));
    viewCB.setToolTipText("Select viewpoint");
    xL.setFont(new java.awt.Font("Dialog", 1, 10));
    xL.setText("X:");
    zL.setFont(new java.awt.Font("Dialog", 1, 10));
    zL.setText("Z:");
    //add items to phenomenaCB in the same order than constants!
    for (int i=0;i<TYPES_OF_PHENOMENA;i++){
      phenomenaCB.addItem(phType(i));
    }
    phenomenaCB.setFont(new java.awt.Font("Dialog", 1, 10));
    phenomenaCB.setPreferredSize(new Dimension(110, 21));
    phenomenaCB.setToolTipText("Select a phenomenon to create");
    phenomenaCB.setMaximumRowCount(5);
    zTF.setFont(new java.awt.Font("Dialog", 0, 10));
    zTF.setPreferredSize(new Dimension(25, 19));
    zTF.setToolTipText("[-"+envRadius+".."+envRadius+"]");
    zTF.setText("0");
    xTF.setFont(new java.awt.Font("Dialog", 0, 10));
    xTF.setPreferredSize(new Dimension(25, 19));
    xTF.setToolTipText("[-"+envRadius+".."+envRadius+"]");
    xTF.setText("0");
    bCreatePhenomena.setFont(new java.awt.Font("Dialog", 1, 10));
    bCreatePhenomena.setToolTipText("Create phenomenon at (z,x) with selected radius");
    bCreatePhenomena.setMargin(new Insets(0, 4, 0, 4));
    bCreatePhenomena.setText("Create");
    bCreatePhenomena.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        bCreatePhenomena_actionPerformed(e);
      }
    });
    radiusL.setFont(new java.awt.Font("Dialog", 1, 10));
    radiusL.setText("radius:");
    radiusTF.setFont(new java.awt.Font("Dialog", 0, 10));
    radiusTF.setPreferredSize(new Dimension(25, 19));
    radiusTF.setToolTipText("radius of phenomenon");
    radiusTF.setText("1");
    delayL.setFont(new java.awt.Font("Dialog", 1, 10));
    delayL.setText("Delay:");
    delayTF.setFont(new java.awt.Font("Dialog", 0, 10));
    delayTF.setPreferredSize(new Dimension(25, 19));
    delayTF.setToolTipText("delay per sim step (ms)");
    delayB.setFont(new java.awt.Font("Dialog", 1, 10));
    delayB.setToolTipText("Set delay");
    delayB.setMargin(new Insets(0, 4, 0, 4));
    delayB.setText("Set");
    delayB.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        delayB_actionPerformed(e);
      }
    });
    randomPhRB.setToolTipText("Create phenomena randomly");
    randomPhRB.setText("Random");
    randomPhRB.setFont(new java.awt.Font("Dialog", 1, 10));

    phenomenaPanel.setFont(new java.awt.Font("Dialog", 0, 10));
    phenomenaPanel.setBorder(titledBorder1);
    phenomenaPanel.setPreferredSize(new Dimension(290, 110));
    phenomenaPanel.setLayout(flowLayout2);
    bDeletePhenomena.setFont(new java.awt.Font("Dialog", 1, 10));
    bDeletePhenomena.setToolTipText("Remove selected phenomenon type");
    bDeletePhenomena.setMargin(new Insets(0, 4, 0, 4));
    bDeletePhenomena.setText("Remove");
    bDeletePhenomena.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        bDeletePhenomena_actionPerformed(e);
      }
    });
    ascDelRB.setToolTipText("Delete phenomena in the order created, descending otherwise");
    ascDelRB.setText("Ascending");
    ascDelRB.setFont(new java.awt.Font("Dialog", 1, 10));
    rndCreatePhL.setFont(new java.awt.Font("Dialog", 1, 10));
    rndCreatePhL.setText("Creation Frequency");
    rndCreatePhL.setToolTipText("Frequency for Creating Random Phenomena");
    rndCreatePhS.setPreferredSize(new Dimension(50, 16));
    rndCreatePhS.setBackground(Color.darkGray);
    rndCreatePhS.setValue((int)Math.round(rndCreatePh*100));
    rndCreatePhS.setToolTipText("Frequency for Creating Random Phenomena");
    rndCreatePhS.addMouseListener(new java.awt.event.MouseAdapter() {
      public void mouseReleased(MouseEvent e) {
        rndCreatePhS_ev(e);
      }
    });
    rndCreatePhS.addKeyListener(new java.awt.event.KeyAdapter() {
      public void keyReleased(KeyEvent e) {
        rndCreatePhS_ev(e);
      }
    });

    bStep.setFont(new java.awt.Font("Dialog", 1, 10));
    bStep.setToolTipText("Go one sim step");
    bStep.setMargin(new Insets(0, 4, 0, 4));
    bStep.setText("Step");
    bStep.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        bStep_actionPerformed(e);
      }
    });
    repeatRB.setFont(new java.awt.Font("Dialog", 1, 10));
    repeatRB.setText("Repeat Each");
    repeatRB.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        repeatRB_actionPerformed(e);
      }
    });
    repeatRB.setToolTipText("Repeat initial conditions each");
    repeatTF.setFont(new java.awt.Font("Dialog", 0, 10));
    repeatTF.setPreferredSize(new Dimension(25, 19));
    toolBar.add(bLoad);
    toolBar.add(bSave);
    toolBar.add(bHelp);
    menuFile.add(menuFileNew);
    menuFile.add(menuFileSave);
    menuFile.add(menuFileSaveAs);
    menuFile.add(menuFileLoad);
    menuFile.add(new JSeparator());
    menuFile.add(menuFileExit);
    menuHelp.add(menuHelpAbout);
    menuBar1.add(menuFile);
    menuBar1.add(menuHelp);
    this.setJMenuBar(menuBar1);
    contentPane.add(toolBar, BorderLayout.NORTH);
    contentPane.add(statusBar, BorderLayout.SOUTH);
    GraphicsEnvironment ge = GraphicsEnvironment.getLocalGraphicsEnvironment();
    GraphicsDevice[] gs = ge.getScreenDevices();
    GraphicsConfigTemplate3D gct = new GraphicsConfigTemplate3D();
    Canvas3D canvas3D = new Canvas3D(gs[0].getBestConfiguration(gct));
    canvas3D.setDoubleBufferEnable(true);
    contentPane.add(canvas3D, BorderLayout.CENTER);
    contentPane.add(panelControls, BorderLayout.WEST);
    //panelControls.add(new JLabel("       "), null);
    panelControls.add(bStartStop, null);
    panelControls.add(bStep, null);
    panelControls.add(repeatRB, null);
    panelControls.add(repeatTF, null);
    //panelControls.add(new JLabel("       "), null);

    phenomenaPanel.add(phenomenaCB, null);
    phenomenaPanel.add(zL, null);
    phenomenaPanel.add(zTF, null);
    phenomenaPanel.add(xL, null);
    phenomenaPanel.add(xTF, null);
    phenomenaPanel.add(radiusL, null);
    phenomenaPanel.add(radiusTF, null);
    phenomenaPanel.add(randomPhRB, null);
    phenomenaPanel.add(bCreatePhenomena, null);
    phenomenaPanel.add(bDeletePhenomena, null);
    phenomenaPanel.add(ascDelRB, null);
    phenomenaPanel.add(rndCreatePhL, null);
    phenomenaPanel.add(rndCreatePhS, null);

    panelControls.add(phenomenaPanel, null);
    panelControls.add(bClear, null);
    panelControls.add(bVerbose, null);
    panelControls.add(delayL, null);
    panelControls.add(delayTF, null);
    panelControls.add(delayB, null);

    //panelControls.add(new JLabel("                           "), null);
    panelControls.add(output, null);
    panelControls.add(viewCB, null);

    //set variables
    initVariables();
    ascDelRB.doClick();

    //java3D inits
    TexturedAppearance.setImageObserver(this);//initialize observer TexApps
    scene = createSceneGraph();//Main Scene...
    virtualU = new VirtualUniverse();
    HiResCoord hrc=new HiResCoord();
    Locale locale=new Locale(virtualU,hrc);
    BranchGroup viewBranch=new BranchGroup();
    View view = new View();
    ViewPlatform viewP=new ViewPlatform();
    PhysicalBody physicalB=new PhysicalBody();
    PhysicalEnvironment physicalE=new PhysicalEnvironment();
    view.attachViewPlatform(viewP);
    view.setPhysicalBody(physicalB);
    view.setPhysicalEnvironment(physicalE);
    view.addCanvas3D(canvas3D);
    view.setFrontClipDistance(0.01);
    view.setBackClipDistance(envRadius*0.6);
    viewTrans.setCapability(TransformGroup.ALLOW_TRANSFORM_READ);
    viewTrans.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
    viewTrans.setCapability(TransformGroup.ENABLE_COLLISION_REPORTING);
    viewTrans.addChild(viewP);
    MouseRotate behavior1 = new MouseRotate(viewTrans);
    scene.addChild(behavior1);
    behavior1.setSchedulingBounds(bounds);
    MouseZoom behavior2 = new MouseZoom(viewTrans);
    scene.addChild(behavior2);
    behavior2.setSchedulingBounds(bounds);
    MouseTranslate behavior3 = new MouseTranslate(viewTrans);
    scene.addChild(behavior3);
    behavior3.setSchedulingBounds(bounds);
    KeyNavigatorBehavior keyNavBeh = new KeyNavigatorBehavior(viewTrans);
    keyNavBeh.setSchedulingBounds(bounds);
    scene.addChild(keyNavBeh);
    Transform3D viewT = new Transform3D();
    viewT.set(new AxisAngle4d(1,1,1,-2*Math.PI/3));
    viewT.setTranslation(new Vector3f(0f,50f,0f));
    viewTrans.setTransform(viewT);
    viewBranch.addChild(viewTrans);
    locale.addBranchGraph(viewBranch);
    locale.addBranchGraph(scene);

    this.show();
  }     //end jbInit()

  void initVariables(){//evoke this method after resetting simulation
                       //also in jbInit()
    //these variables should be loaded from simfile!
    t=0;
    //lastID=0;
    Concept.initID(0);
    phenomena=new Vector(20,5);
    phenomena2=null;
    delay=100;
    rndCreatePh=0.5f;
    verbose=true;
    pause=true;
    repeat=false;
    initGUI();
  }

  void initGUI(){
    if (verbose)
      bVerbose.setSelected(true);
    else
      bVerbose.setSelected(false);
    rndCreatePhS.setValue((int)Math.round(rndCreatePh*100));
    if (repeat)
      repeatRB.setSelected(true);
    else
      repeatRB.setSelected(false);
    delayTF.setText(Tools.str(delay));
    repeatTF.setText(Tools.str(period));
  }

  public BranchGroup createSceneGraph() {
  	BranchGroup objRoot = new BranchGroup();

    //background
    Background bg = new Background();
    bg.setApplicationBounds(bounds);
    TexturedAppearance bgApp = new TexturedAppearance("keba/img/eveningsky.jpg");
    BranchGroup backGeoBranch = new BranchGroup();
    Sphere sphereObj = new Sphere(1.0f, Sphere.GENERATE_NORMALS |
    			                        Sphere.GENERATE_NORMALS_INWARD |
    				                      Sphere.GENERATE_TEXTURE_COORDS, 45, bgApp);
    backGeoBranch.addChild(sphereObj);
    bg.setGeometry(backGeoBranch);
    objRoot.addChild(bg);
    /*ExponentialFog fog =new ExponentialFog(new Color3f(0.5f,0.5f,0.5f),1.0f);
    fog.setInfluencingBounds(bounds);
    objRoot.addChild(fog);*/

    //lights
    Color3f lColor1 = new Color3f(0.8f, 0.9f, 1.0f);
    Color3f lColor2 = new Color3f(0.6f, 0.7f, 0.9f);
    Vector3f lDir1  = new Vector3f(1.0f, -1.0f, 1.0f);
    Vector3f lDir2  = new Vector3f(-1.0f, -1.0f, -1.0f);
    DirectionalLight lgt1 = new DirectionalLight(lColor1, lDir1);
    DirectionalLight lgt2 = new DirectionalLight(lColor2, lDir2);
    AmbientLight alight=new AmbientLight(lColor1);
    lgt1.setInfluencingBounds(bounds);
    lgt2.setInfluencingBounds(bounds);
    alight.setInfluencingBounds(bounds);
    objRoot.addChild(lgt1);
    objRoot.addChild(lgt2);
    objRoot.addChild(alight);

    //floor
    TexturedAppearance floorApp = new TexturedAppearance("keba/img/softbluemarble.jpg");
    TexCoordGeneration floorTCG=new TexCoordGeneration();
    floorTCG.setPlaneS(new Vector4f(0.1f,0.1f,0,0));
    floorTCG.setPlaneT(new Vector4f(0,0.1f,0.1f,0));
    floorApp.setTexCoordGeneration(floorTCG);
    com.sun.j3d.utils.geometry.Box floorBox =
        new com.sun.j3d.utils.geometry.Box(envRadius,1f,envRadius,
        Primitive.GENERATE_TEXTURE_COORDS, floorApp);
    objRoot.addChild(floorBox);

    objRoot.setCapability(BranchGroup.ALLOW_CHILDREN_EXTEND);
    objRoot.setCapability(BranchGroup.ALLOW_DETACH);
    objRoot.setCapability(BranchGroup.ALLOW_CHILDREN_READ);
    objRoot.setCapability(BranchGroup.ALLOW_CHILDREN_WRITE);
    objRoot.setCapability(BranchGroup.ENABLE_COLLISION_REPORTING);
  	return objRoot;
  }

////////////////////////////////////////////////////

  public static long assignID(){//assigns unique ID to Phenomena
    lastID++;//need to set lastID when loading simulations!
    return lastID;
  }
  public static String phType(int type){
    if (type==ANIMAT_RULE) return new String("Rule-based Animat");
    if (type==ANIMAT_MAES) return new String("Maes Animat");
    if (type==ANIMAT_KEBA) return new String("KEBA Animat");
    if (type==ANIMAT_NN) return new String("Neural Net Animat");
    if (type==ANIMAT_BRAIT) return new String("Braitenberg Animat");
    if (type==FOOD) return new String("Food");
    if (type==ROCK) return new String("Rock");
    if (type==RAIN) return new String("Rain");
    if (type==LIGHTNING) return new String("Lightning");
    if (type==SPOT_RED) return new String("Red Spot");
    if (type==SPOT_GREEN) return new String("Green Spot");
    if (type==SPOT_BLUE) return new String("Blue Spot");
    if (type==SPOT_YELLOW) return new String("Yellow Spot");
    if (type==SPOT_WHITE) return new String("White Spot");
    if (type==SPOT_BLACK) return new String("Black Spot");
    if (type==SPOT_RND) return new String("Random Spot");
    return new String("Unknown phenomenon");
  }

  public static void addPhenomenon(Phenomenon ph, boolean manual){
    phenomena.add(ph);
    scene.addChild(ph);
    if (manual){
      if (verbose)
        output.append(phType(ph.type)+" created at: "+String.valueOf(ph.z)+
                      ", "+String.valueOf(ph.x)+", radius: "+
                      String.valueOf(ph.radius)+"\n");
      statusBar.setText(phType(ph.type)+" created...");
    }
  }

  public static void removePhenomenon(Phenomenon ph, boolean manual){
    if (manual){
      if (verbose)
        output.append(phType(ph.type)+" at "+String.valueOf(ph.z)+
                      ", "+String.valueOf(ph.x)+", radius: "+
                      String.valueOf(ph.radius)+" removed\n");
        statusBar.setText(phType(ph.type)+" removed...");
    }
    ph.destroy();
    phenomena.removeElement(ph);
  }

  public static Phenomenon getPhenomenon(long id){
    Phenomenon ph;
    for (int i=0;i<phenomena.size();i++){
      ph=(Phenomenon)phenomena.elementAt(i);
      if (ph.id==id)
        return ph;
    }
    return null;
  }

  public static void removeAnimat(Animat a){
    removePhenomenon(a, false);
    if (verbose)
      output.append("Animat "+a.name+ " removed...\n");
    statusBar.setText("Animat "+a.name+ " removed...");
  }

  public void removeAllPhen(boolean manual){
    Phenomenon ph;
    cleanAnimats(RESET);
    for (int i=phenomena.size()-1;i>=0;i--){
      ph=(Phenomenon) phenomena.elementAt(i);
      removePhenomenon(ph, manual);
    }
  }

  public void showAllPhen(){
    Phenomenon ph;
    for (int i=0;i<phenomena.size();i++){
      ph=(Phenomenon) phenomena.elementAt(i);
      ph.restore3D();
      scene.addChild(ph);
    }
  }

  public void createPhRnd(){//create phenomena randomly
    Phenomenon ph;
    float when=rnd.nextFloat();
    float z=0,x=0,radius=-1;
    /*do
      when=rnd.nextFloat();//don't want zeroes or ones...
    while ((when==0)||(when==1));
    if (Math.floor(when*WHEN_ANIMAT/rndCreatePh)==0){
      z=(rnd.nextFloat()*ENV_RADIUS*2)-ENV_RADIUS;
      x=(rnd.nextFloat()*ENV_RADIUS*2)-ENV_RADIUS;
      radius=rnd.nextFloat()+0.5f;
      ph=new Animat(z,x,radius,assignID());
      addPhenomenon(ph, true);
    }*/
    do
      when=rnd.nextFloat();//don't want zeroes or ones...
    while ((when==0)||(when==1));
    if (Math.floor(when*WHEN_FOOD/rndCreatePh)==0){
      z=(rnd.nextFloat()*envRadius*2)-envRadius;
      x=(rnd.nextFloat()*envRadius*2)-envRadius;
      radius=rnd.nextFloat()+0.5f;
      ph=new Food(z,x,radius,assignID());
      addPhenomenon(ph, true);
    }
    do
      when=rnd.nextFloat();//don't want zeroes or ones...
    while ((when==0)||(when==1));
    if (Math.floor(when*WHEN_ROCK/rndCreatePh)==0){
      z=(rnd.nextFloat()*envRadius*2)-envRadius;
      x=(rnd.nextFloat()*envRadius*2)-envRadius;
      radius=rnd.nextFloat()+0.5f;
      ph=new Rock(z,x,radius,assignID());
      addPhenomenon(ph, true);
    }
    do
      when=rnd.nextFloat();//don't want zeroes or ones...
    while ((when==0)||(when==1));
    if (Math.floor(when*WHEN_RAIN/rndCreatePh)==0){
      z=(rnd.nextFloat()*envRadius*2)-envRadius;
      x=(rnd.nextFloat()*envRadius*2)-envRadius;
      radius=rnd.nextFloat()+0.5f;
      ph=new Rain(z,x,radius,assignID());
      addPhenomenon(ph, true);
    }
    do
      when=rnd.nextFloat();//don't want zeroes or ones...
    while ((when==0)||(when==1));
    if (Math.floor(when*WHEN_LIGHTNING/rndCreatePh)==0){
      z=(rnd.nextFloat()*envRadius*2)-envRadius;
      x=(rnd.nextFloat()*envRadius*2)-envRadius;
      radius=rnd.nextFloat()+0.5f;
      ph=new Lightning(z,x,radius,assignID());
      addPhenomenon(ph, true);
    }
    do
      when=rnd.nextFloat();//don't want zeroes or ones...
    while ((when==0)||(when==1));
    if (Math.floor(when*WHEN_SPOT_RED/rndCreatePh)==0){
      z=(rnd.nextFloat()*envRadius*2)-envRadius;
      x=(rnd.nextFloat()*envRadius*2)-envRadius;
      radius=rnd.nextFloat()+0.5f;
      ph=new SpotRed(z,x,radius,assignID());
      addPhenomenon(ph, true);
    }
    do
      when=rnd.nextFloat();//don't want zeroes or ones...
    while ((when==0)||(when==1));
    if (Math.floor(when*WHEN_SPOT_GREEN/rndCreatePh)==0){
      z=(rnd.nextFloat()*envRadius*2)-envRadius;
      x=(rnd.nextFloat()*envRadius*2)-envRadius;
      radius=rnd.nextFloat()+0.5f;
      ph=new SpotGreen(z,x,radius,assignID());
      addPhenomenon(ph, true);
    }
    do
      when=rnd.nextFloat();//don't want zeroes or ones...
    while ((when==0)||(when==1));
    if (Math.floor(when*WHEN_SPOT_BLUE/rndCreatePh)==0){
      z=(rnd.nextFloat()*envRadius*2)-envRadius;
      x=(rnd.nextFloat()*envRadius*2)-envRadius;
      radius=rnd.nextFloat()+0.5f;
      ph=new SpotBlue(z,x,radius,assignID());
      addPhenomenon(ph, true);
    }
    do
      when=rnd.nextFloat();//don't want zeroes or ones...
    while ((when==0)||(when==1));
    if (Math.floor(when*WHEN_SPOT_YELLOW/rndCreatePh)==0){
      z=(rnd.nextFloat()*envRadius*2)-envRadius;
      x=(rnd.nextFloat()*envRadius*2)-envRadius;
      radius=rnd.nextFloat()+0.5f;
      ph=new SpotYellow(z,x,radius,assignID());
      addPhenomenon(ph, true);
    }
    do
      when=rnd.nextFloat();//don't want zeroes or ones...
    while ((when==0)||(when==1));
    if (Math.floor(when*WHEN_SPOT_WHITE/rndCreatePh)==0){
      z=(rnd.nextFloat()*envRadius*2)-envRadius;
      x=(rnd.nextFloat()*envRadius*2)-envRadius;
      radius=rnd.nextFloat()+0.5f;
      ph=new SpotWhite(z,x,radius,assignID());
      addPhenomenon(ph, true);
    }
    do
      when=rnd.nextFloat();//don't want zeroes or ones...
    while ((when==0)||(when==1));
    if (Math.floor(when*WHEN_SPOT_BLACK/rndCreatePh)==0){
      z=(rnd.nextFloat()*envRadius*2)-envRadius;
      x=(rnd.nextFloat()*envRadius*2)-envRadius;
      radius=rnd.nextFloat()+0.5f;
      ph=new SpotBlack(z,x,radius,assignID());
      addPhenomenon(ph, true);
    }
    do
      when=rnd.nextFloat();//don't want zeroes or ones...
    while ((when==0)||(when==1));
    if (Math.floor(when*WHEN_SPOT_RND/rndCreatePh)==0){
      z=(rnd.nextFloat()*envRadius*2)-envRadius;
      x=(rnd.nextFloat()*envRadius*2)-envRadius;
      radius=rnd.nextFloat()+0.5f;
      ph=new SpotRnd(z,x,radius,assignID());
      addPhenomenon(ph, true);
    }
  }

  public static void transform (Phenomenon ph){
    //create+destroy
    Phenomenon nph;
    switch(ph.type){
      /*case ANIMAT:
        //implement in Animat.step()...
      break;*/
      case FOOD:
        //kak decompose...
        removePhenomenon(ph, true);
      break;
      case ROCK:
        //zzzz....
      break;
      case RAIN://rain turns into food
        nph=new Food(ph.z,ph.x,ph.radius/10,assignID());
        addPhenomenon(nph, true);
        removePhenomenon(ph, true);
      break;
      case LIGHTNING://lightning turns into rain
        nph=new Rain(ph.z,ph.x,ph.radius*10,assignID());
        addPhenomenon(nph, true);
        removePhenomenon(ph, true);
      break;
      case SPOT_RED:
        removePhenomenon(ph, true);
      break;
      case SPOT_GREEN:
        removePhenomenon(ph, true);
      break;
      case SPOT_BLUE:
        removePhenomenon(ph, true);
      break;
      case SPOT_YELLOW:
        removePhenomenon(ph, true);
      break;
      case SPOT_WHITE:
        removePhenomenon(ph, true);
      break;
      case SPOT_BLACK:
        removePhenomenon(ph, true);
      break;
      case SPOT_RND:
        removePhenomenon(ph, true);
      break;
    }

  }

  public static float[] closest(Phenomenon ph, int type){
    //returns id & d of closest ph2 from ph with id,
    //d is negative if ph "touches" ph2
    long id=-1;
    Phenomenon ph2;
    float d, mind=Float.MAX_VALUE;//maximum distance
    for (int i=0;i<phenomena.size();i++){
      ph2=(Phenomenon)phenomena.elementAt(i);
      if ((type==ph2.type)&&(ph.id!=ph2.id)){
        d=(float)Math.sqrt(Math.pow(ph.x-ph2.x,2)+Math.pow(ph.z-ph2.z,2))
          -ph.radius-ph2.radius;
        if (d<=mind){
          mind=d;
          id=ph2.id;
        }
      }
    }
    float[]id_d=new float[2];
    id_d[0]=id;
    id_d[1]=mind;
    return id_d;
  }
  public static float[] maxpond(Phenomenon ph, int type){
    //returns distance to ph with max ponderation between radius and distance,
    //d is negative if ph "touches" ph2
    long id=-1;
    Phenomenon ph2;
    float d=Float.MAX_VALUE, pond, maxpond=Float.MIN_VALUE;
    for (int i=0;i<phenomena.size();i++){
      ph2=(Phenomenon)phenomena.elementAt(i);
      if ((type==ph2.type)&&(ph.id!=ph2.id)){
        pond=(float)(ph2.radius/Math.sqrt(Math.pow(ph.x-ph2.x,2)+Math.pow(ph.z-ph2.z,2)));
        if (pond>maxpond){
          maxpond=pond;
          d=(float)Math.sqrt(Math.pow(ph.x-ph2.x,2)+Math.pow(ph.z-ph2.z,2))
            -ph.radius-ph2.radius;
          id=ph2.id;
        }
      }
    }
    float[]id_d=new float[2];
    id_d[0]=id;
    id_d[1]=d;
    return id_d;
  }


  public void cleanAnimats(int mode){
    Phenomenon ph;
    Animat an;
    for (int i=0;i<phenomena.size();i++){
      ph=(Phenomenon)phenomena.elementAt(i);
      if (ph.type<TYPES_OF_ANIMAT){
        an=(Animat)phenomena.elementAt(i);
        an.clean(mode);
      }
    }
  }

  public void restoreAnimats(){
    Phenomenon ph;
    Animat an;
    for (int i=0;i<phenomena.size();i++){
      ph=(Phenomenon)phenomena.elementAt(i);
      if (ph.type<TYPES_OF_ANIMAT){
        an=(Animat)phenomena.elementAt(i);
        an.restore();
      }
    }
  }

  public void savePhenomena() {
    FilePermission perm = new java.io.FilePermission(".", "write");
    FileOutputStream ostream = null ;
    try {
      try {
        ostream = new FileOutputStream(phenFile);
      } catch(SecurityException se) {
        output.append(se.getMessage());
      }
      ObjectOutputStream p = new ObjectOutputStream(ostream);
      cleanAnimats(SAVE);
      p.writeObject(phenomena);
      p.flush();
      ostream.close();
      restoreAnimats();
    } catch(IOException ioe) {
        output.append(ioe.toString()+"\n");
    }
  }

  public void loadPhenomena() {
    FilePermission perm = new java.io.FilePermission(".", "read");
    FileInputStream istream = null ;
    try {
      try {
        istream = new FileInputStream(phenFile);
      } catch(SecurityException se) {
        output.append(se.getMessage());
      }
      ObjectInputStream p = new ObjectInputStream(istream);
      removeAllPhen(false);
      try {
        phenomena = (Vector)p.readObject();
      } catch (java.lang.ClassNotFoundException cnfe) {
        output.append(cnfe.getMessage());
      }
      showAllPhen();
      restoreAnimats();
    } catch(IOException ioe) {
      output.append(ioe.toString()+"\n");
    }
  }

  public void repeatsim(){
    Phenomenon ph, ph2;
    if (verbose)
      output.append("Restoring simulation to initial conditions...");
    phenomena2=(Vector)phenomena.clone();
    loadPhenomena();
    for (int i=0;i<phenomena2.size();i++){
      ph=(Phenomenon)phenomena2.elementAt(i);
      if (ph.type==ANIMAT_KEBA){
        AnimatKEBA an=(AnimatKEBA)phenomena2.elementAt(i);
        for (int j=0;j<phenomena.size();j++){
          ph2=(Phenomenon)phenomena.elementAt(j);
          if (ph2.id==an.id){
            AnimatKEBA an2=(AnimatKEBA)phenomena.elementAt(j);
            an2.keb=an.keb;
            an2.time=an.time;
            //an2.setZ(an.z);
            //an2.setX(an.x);
            //an2.setTh(an.th);
            //an2.setEnergy(an.energy);
            //an2.setThirst(an.thirst);
            //an2.setHunger(an.hunger);
          }
        }
      }
    }
    if (verbose)
      output.append(" done!\n");
  }

  public static void iniStatFile(String filename, long id) {
    try {
      ostream = new StatStream(filename, id);
    } catch(IOException ioe) {
      System.out.println(ioe.getMessage());
    }
    stats.addElement(ostream);
  }
  public static void closeStatFile(long id) {//actually not needed, thanks to flush...
    for (int i=0;i<stats.size();i++){
      ostream=(StatStream)stats.elementAt(i);
      if (ostream.id==id){
        try {
          ostream.close();
        } catch(IOException ioe) {
          System.out.println(ioe.getMessage());
        }
      }
    }
  }
  public static void doStats(String str, long id) {
    for (int i=0;i<stats.size();i++){
      ostream=(StatStream)stats.elementAt(i);
      if (ostream.id==id){
        try { //write to file
          ostream.write(str.getBytes());
          ostream.flush();
        } catch(IOException ioe) {
          System.out.println(ioe.getMessage());
        }
      }
    }
  }


  public void run() {
    Thread myThread = Thread.currentThread();
    while (sim == myThread) { //Simulation
      step();
      try {
        sim.sleep(delay);
      } catch (InterruptedException insomnia) { }
    }
  }

  public void stop() {
      sim = null;//stop sim thread
  }

  public void step() {
    Phenomenon p;
    if ((repeat)&&((t % period) == trans))
      repeatsim();
    for (int i=0;i<phenomena.size();i++){
      p= (Phenomenon)phenomena.elementAt(i);
      p.step();
    }
    if (rndCreatePh>0){
      createPhRnd();
    }
    t++;
    if (verbose) {
      output.append("t: "+String.valueOf(t)+"\n");
    }
  }

  public static void main(String argv[]){
    //catch parameters (if any) to set size of Frame
    boolean params=false;
    int width=620, height=420, radius=50;
    try {
      if (argv[0]!=null)
        params=true;
    }catch(ArrayIndexOutOfBoundsException e){}
    if(params){
      try {
        radius = Integer.valueOf(argv[0]).intValue();
      } catch (NumberFormatException nfe) {
        System.out.println(nfe.getMessage());
        System.exit(-1);
      }
    try {
      if (argv[1]!=null){
        try {
          width = Integer.valueOf(argv[1]).intValue();
        } catch (NumberFormatException nfe) {
          System.out.println(nfe.getMessage());
          System.exit(-1);
        }
        try {
          height = Integer.valueOf(argv[2]).intValue();
        } catch (NumberFormatException nfe) {
          System.out.println(nfe.getMessage());
          System.exit(-1);
        }
      }
    }catch(ArrayIndexOutOfBoundsException e){}
    }
    KEBA keba=new KEBA(radius,width, height);
  }

//**********************************************************
//Functions invoked from GUI (Action Events)

  //File | New action performed
  public void fileNew_actionPerformed(ActionEvent e) {
    //reset...
    output.append("Resetting KEBA...");
    removeAllPhen(true);
    initVariables();
    filename=null;
    bSave.setToolTipText("Save File");
    output.append(" done!\n");
  }

  //File | Save action performed
  public void fileSave_actionPerformed(ActionEvent e) {
    if ((filename==null)||(filename.compareTo("")==0)||(filename.compareTo("nullnull")==0))
      fileSaveAs_actionPerformed(e);
    else{
      output.append("Saving Virtual Environment in file "+filename+" ...\n");
      FilePermission perm = new java.io.FilePermission(".", "write");
      FileOutputStream ostream = null ;
      try {
        try {
          ostream = new FileOutputStream(filename);
        } catch(SecurityException se) {
          output.append(se.getMessage());
        }
        ObjectOutputStream p = new ObjectOutputStream(ostream);
        cleanAnimats(SAVE);
        p.writeObject(phenomena);
        p.writeObject(phenomena2);
        p.writeLong(t);
        p.writeLong(lastID);
        p.writeLong(Concept.lastID);
        p.writeLong(delay);
        p.writeLong(period);
        p.writeLong(trans);
        p.writeBoolean(repeat);
        p.writeBoolean(verbose);
        p.writeFloat(rndCreatePh);
        p.flush();
        ostream.close();
        output.append("Virtual Environment saved.\n");
        statusBar.setText("Virtual Environment saved.");
        restoreAnimats();
      } catch(IOException ioe) {
          output.append(ioe.toString()+"\n");
      }
    }
  }

  //File | Save As action performed
  public void fileSaveAs_actionPerformed(ActionEvent e) {
    FileDialog fd = new FileDialog(new Frame(),"Save Virtual Environment",FileDialog.SAVE);
    fd.setVisible(true);
    filename = new String(fd.getDirectory()+fd.getFile());
    if (filename.compareTo("nullnull")!=0){
      fileSave_actionPerformed(e);
      bSave.setToolTipText("Save File ("+filename+")");
    }
    else
      output.append("Saving cancelled.\n");
  }

  //File | Load action performed
  public void fileLoad_actionPerformed(ActionEvent e) {
    String loadFile=null;
    FileDialog fd = new FileDialog(new Frame(),"Load Virtual Environment",FileDialog.LOAD);
    fd.setVisible(true);
    loadFile = new String(fd.getDirectory()+fd.getFile());
    if(loadFile.compareTo("nullnull")!=0) {
      output.append("Loading Virtual Environment from file "+loadFile+"...\n");
      FilePermission perm = new java.io.FilePermission(".", "read");
      FileInputStream istream = null ;
      try {
        try {
          istream = new FileInputStream(loadFile);
        } catch(SecurityException se) {
          output.append(se.getMessage());
        }
        ObjectInputStream p = new ObjectInputStream(istream);
        removeAllPhen(false);
        try {
          phenomena = (Vector)p.readObject();
          phenomena2 = (Vector)p.readObject();
        } catch (java.lang.ClassNotFoundException cnfe) {
          output.append(cnfe.getMessage());
        }
        t=p.readLong();
        lastID+=p.readLong();
        Concept.initID(p.readLong());
        delay=p.readLong();
        period=p.readLong();
        trans=p.readLong();
        repeat=p.readBoolean();
        verbose=p.readBoolean();
        rndCreatePh=p.readFloat();
        istream.close();
        initGUI();
        filename=loadFile;
        bSave.setToolTipText("Save File ("+filename+")");
        showAllPhen();
        restoreAnimats();
        output.append("Virtual Environment loaded.\n");
        statusBar.setText("Virtual Environment loaded.");
      } catch(IOException ioe) {
        output.append(ioe.toString()+"\n");
      }
    } else {
      output.append("Loading cancelled.\n");
    }
  }

  //File | Exit action performed
  public void fileExit_actionPerformed(ActionEvent e) {
    System.out.println("So what makes us so special, then???");
    System.exit(0);
  }

  //Help | About action performed
  public void helpAbout_actionPerformed(ActionEvent e) {
    KEBA_AboutBox dlg = new KEBA_AboutBox(this);
    Dimension dlgSize = dlg.getPreferredSize();
    Dimension frmSize = getSize();
    Point loc = getLocation();
    dlg.setLocation((frmSize.width - dlgSize.width) / 2 + loc.x, (frmSize.height - dlgSize.height) / 2 + loc.y);
    dlg.setModal(true);
    dlg.show();
  }

  void bLoad_actionPerformed(ActionEvent e) {
    fileLoad_actionPerformed(null);
  }

  void bSave_actionPerformed(ActionEvent e) {
    fileSave_actionPerformed(null);
  }

  void bHelp_actionPerformed(ActionEvent e) {
    output.append("Ha ha!...\n");
  }

  //Overridden so we can exit when window is closed
  protected void processWindowEvent(WindowEvent e) {
    super.processWindowEvent(e);
    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
      fileExit_actionPerformed(null);
    }
  }

  void bClear_actionPerformed(ActionEvent e) {
    output.setText("Nice and clean...\n");
  }

  void bStartStop_actionPerformed(ActionEvent e) {
    if (pause){//start
      bStartStop.setToolTipText("Stop simulation");
      bStartStop.setText("Stop!!!");
      sim = new Thread(this, "Simulation");
      sim.setPriority(Thread.NORM_PRIORITY);
      sim.start();
      output.append("Simulation started.\n");
      statusBar.setText("Simulation started...");
    }else{//stop
      bStartStop.setToolTipText("Start simulation");
      bStartStop.setText("Start!");
      stop();
      output.append("Simulation stopped.\n");
      statusBar.setText("Simulation stopped...");
    }
    pause=!pause;
  }

  void bVerbose_actionPerformed(ActionEvent e) {
    if(verbose)
      output.append("OK, I'll shut up.\n");
    else
      output.append("Information just for you!\n");
    verbose =! verbose;
  }

  void viewCB_actionPerformed(ActionEvent e) {//change views in VirtualUniverse
    int index = viewCB.getSelectedIndex();
    Transform3D viewT = new Transform3D();
    switch(index){
      case 0:
        viewT.set(new AxisAngle4d(1,1,1,-2*Math.PI/3));
        viewT.setTranslation(new Vector3f(0f,50f,0f));
        viewTrans.setTransform(viewT);
      break;
      case 1:
        viewT.setTranslation(new Vector3f(0f,2f,10f));
        viewTrans.setTransform(viewT);
      break;
      case 2:
        viewT.rotY(7*Math.PI/4);
        viewT.setTranslation(new Vector3f(-envRadius,2f,envRadius));
        viewTrans.setTransform(viewT);
      break;
      case 3:
        viewT.set(new AxisAngle4d(1,1,1,-2*Math.PI/3));
        viewT.setTranslation(new Vector3f(0f,envRadius*2.5f,0f));
        viewTrans.setTransform(viewT);
      break;
      case 4:
        viewT.rotX(-Math.PI/8);
        viewT.setTranslation(new Vector3f(0f,20f,60f));
        viewTrans.setTransform(viewT);
      break;
    }
    if (verbose)
      output.append("Viewpoint set\n");
  }

  void delayB_actionPerformed(ActionEvent e) {//set delay
    boolean ok=true;
    long dlyprov =-1;
    try {
      dlyprov = Long.valueOf(delayTF.getText()).longValue();
    }
    catch (NumberFormatException nfe) {
      output.append("Please fill the delay field correctly!\n");
      ok = false;
    }
    if (ok) {
      if (dlyprov < 0) {
        output.append("Delay can't be negative!\n");
      } else {
        delay = dlyprov;
        output.append("New delay rate: "+String.valueOf(delay)+" milliseconds per sim step\n");
      }
    }
  }

  void bCreatePhenomena_actionPerformed(ActionEvent e) {
    Phenomenon ph=null;
    boolean ok=true;
    float z=0,x=0,radius=-1;
    int index = phenomenaCB.getSelectedIndex();
    if(randomPhRB.isSelected()){//generate random values
      z=(rnd.nextFloat()*envRadius*2)-envRadius;
      x=(rnd.nextFloat()*envRadius*2)-envRadius;
      radius=rnd.nextFloat()+0.5f;
    }else{//get data
      try {
        z = Float.valueOf(zTF.getText()).floatValue();
        x = Float.valueOf(xTF.getText()).floatValue();
        radius = Float.valueOf(radiusTF.getText()).floatValue();
      }
      catch (NumberFormatException nfe) {
        output.append("Please fill the fields correctly!\n");
        ok = false;
      }
      if (radius < 0) {
        output.append("Radius can't be negative!\n");
        ok=false;
      }
    }
    if(ok){//create phenomenon
      switch(index){
        case ANIMAT_RULE:
          ph=new AnimatRule(z,x,radius,assignID());
        break;
        case ANIMAT_MAES:
          ph=new AnimatMaes(z,x,radius,assignID());
        break;
        case ANIMAT_KEBA:
          ph=new AnimatKEBA(z,x,radius,assignID());
        break;
        case ANIMAT_NN:
          ph=new AnimatNN(z,x,radius,assignID());
        break;
        case ANIMAT_BRAIT:
          ph=new AnimatBrait(z,x,radius,assignID());
        break;
        case FOOD:
          ph=new Food(z,x,radius,assignID());
        break;
        case ROCK:
          ph=new Rock(z,x,radius,assignID());
        break;
        case RAIN:
          ph=new Rain(z,x,radius,assignID());
        break;
        case LIGHTNING:
          ph=new Lightning(z,x,radius,assignID());
        break;
        case SPOT_RED:
          ph=new SpotRed(z,x,radius,assignID());
        break;
        case SPOT_GREEN:
          ph=new SpotGreen(z,x,radius,assignID());
        break;
        case SPOT_BLUE:
          ph=new SpotBlue(z,x,radius,assignID());
        break;
        case SPOT_YELLOW:
          ph=new SpotYellow(z,x,radius,assignID());
        break;
        case SPOT_WHITE:
          ph=new SpotWhite(z,x,radius,assignID());
        break;
        case SPOT_BLACK:
          ph=new SpotBlack(z,x,radius,assignID());
        break;
        case SPOT_RND:
          ph=new SpotRnd(z,x,radius,assignID());
        break;
      }
      if (ph!=null)
        addPhenomenon(ph, true);
    }//ok
  }

  void bDeletePhenomena_actionPerformed(ActionEvent e) {
    Phenomenon ph;
    boolean stillmore=true;
    int index = phenomenaCB.getSelectedIndex();
    if (index<TYPES_OF_ANIMAT){
      output.append("Animats must be removed from their respective window.\n");
    }else{
      int i=0;
      while((i<phenomena.size())&&(stillmore)){
        if (ascDelRB.isSelected())//delete in FIFO fashion
          ph=(Phenomenon)phenomena.elementAt(i);
        else//delete in LIFO fashion
          ph=(Phenomenon)phenomena.elementAt(phenomena.size()-1-i);
        if (ph.type==index){
          stillmore=false;
          removePhenomenon(ph, true);
        }
        i++;
      }
      if (stillmore){
        output.append("No more "+phType(index)+"s in virtual environment...\n");
        statusBar.setText("");
      }
      //output.append(String.valueOf(phenomena.size())+ " phenomena left...\n");
    }

  }

  void bStep_actionPerformed(ActionEvent e) {
    if (pause)
      step();
  }

  void repeatRB_actionPerformed(ActionEvent e) {
    Phenomenon ph;
    boolean ok=true;
    long periodprov =-1;
    if (!repeat){
      try {
        periodprov = Long.valueOf(repeatTF.getText()).longValue();
      }
      catch (NumberFormatException nfe) {
        output.append("Please fill the Repeat field correctly!\n");
        ok = false;
      }
      if (ok) {
        if (periodprov < 0) {
          output.append("Repeat period can't be negative!\n");
        } else {
          period = periodprov;
          trans=t % period;
          savePhenomena();
          output.append("Each "+ String.valueOf(period)+
          " time steps, animats' positions and environment and will be restored to present state.\n");
        }
      }

    }
    else
      output.append("Environment and animats will not be repeated\n");

    repeat=!repeat;
  }

  void rndCreatePhS_ev(MouseEvent e) {
    rndCreatePhS_ev();
  }
  void rndCreatePhS_ev(KeyEvent e) {
    rndCreatePhS_ev();
  }
  void rndCreatePhS_ev() {
    float tmp=rndCreatePhS.getValue();
    rndCreatePh=tmp/100;
    if (verbose)
      output.append("New phenomena creation frequency= "+Tools.str(rndCreatePh,4)+"\n");
  }

}