
/**
 * Title:        "Knowledge Emerging from Behaviour" Architecture<p>
 * Description:  <p>
 * Copyright:    Copyright (c) Carlos Gershenson, C.Gershenson@sussex.ac.uk<p>
 * Company:      COGS, University of Sussex<p>
 * @author Carlos Gershenson, C.Gershenson@sussex.ac.uk
 * @version 3.0
 */
package keba;

import javax.media.j3d.*;
import javax.vecmath.*;
import com.sun.j3d.utils.geometry.*;
import keba.tools.*;
import java.awt.Color;

public class Lightning extends Phenomenon {

  public Lightning(float nz, float nx, float nradius, long nid) {
    //z x radius colour flavourp flavourn odourp odourn hardness loudness id type
    super(nz,nx,nradius,new Color(0.9f, 1.0f, 1.0f),0.0f,0.0f,0.0f,0.0f,0.05f,0.98f,
    nid, KEBA.LIGHTNING);
    init3D();
  }

  void init3D(){
    int height = 100;
    t=new STransform3D();
    t.setTranslation(new Vector3f(x,1+height/2,z));
    tg.setTransform(t);
    TexturedAppearance tapp=new TexturedAppearance("keba/img/storm.jpg");
    Color3f aColor    = new Color3f(1.0f, 1.0f, 1.0f);
    Color3f eColor    = new Color3f(0.9f, 0.9f, 1.0f);
    Color3f dColor    = new Color3f(colour);
    Color3f sColor    = new Color3f(0.5f, 0.9f, 0.9f);
    Material mat = new Material(aColor, eColor, dColor, sColor, 100.0f);
    mat.setLightingEnable(true);
    tapp.setMaterial(mat);
    TexCoordGeneration TCG=new TexCoordGeneration();
    TCG.setPlaneS(new Vector4f(0.5f,0,0,0));
    TCG.setPlaneT(new Vector4f(0,0.05f,0,0));
    tapp.setTexCoordGeneration(TCG);
    tapp.setTransparencyAttributes(
       new TransparencyAttributes(TransparencyAttributes.FASTEST, 0.7f));
    tg.addChild(new Cylinder(radius,height,Primitive.GENERATE_NORMALS
                           | Primitive.GENERATE_TEXTURE_COORDS,tapp));
  }

  void step() {
    time++;
    //sound???
    if (time>=10){//transform Lightning into Rain...
      KEBA.transform(this);
    }
  }

}