
/**
 * Title:        "Knowledge Emerging from Behaviour" Architecture<p>
 * Description:  <p>
 * Copyright:    Copyright (c) Carlos Gershenson, C.Gershenson@sussex.ac.uk<p>
 * Company:      COGS, University of Sussex<p>
 * @author Carlos Gershenson, C.Gershenson@sussex.ac.uk
 * @version 3.0
 */
package keba;

import java.awt.Color;
import java.io.Serializable;
import javax.media.j3d.*;
import keba.tools.*;

public abstract class Phenomenon extends BranchGroup implements Serializable, Cloneable{
//Abstract Phenomenon class
//Phenomena are objects in VirtualUniverse (BranchGroup)
  long id;
  int type;
  long time;//phenomenon's time
  STransformGroup tg;
  STransform3D t;
  float z,x;//coords
  float radius;//to measure size...
  //all of the following are relative to the perception of the animats
  Color colour;
  float[] flavour=new float[2];//is it tasty? {good,bad}
  float[] odour=new float[2];//{good,bad}
  float hardness;
  float loudness;

  protected Phenomenon(float nz, float nx,float nradius, Color ncolour,
                    float nflavourp, float nflavourn,float nodourp,
                    float nodourn,float nhardness, float nloudness,
                    long nid, int ntype) {
    super();
    id=nid;
    type=ntype;
    time=0;
    sinit3D();
    z=nz;
    x=nx;
    radius=nradius;
    colour=ncolour;
    flavour[0]=nflavourp;
    flavour[1]=nflavourn;
    odour[0]=nodourp;
    odour[1]=nodourn;
    hardness=nhardness;
    loudness=nloudness;
  }

  protected Object clone() throws CloneNotSupportedException{
    return super.clone();
  }

  public void sinit3D(){
    tg=new STransformGroup();
    tg.setCapability(TransformGroup.ALLOW_TRANSFORM_READ);
    tg.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
    this.addChild(tg);
    this.setCapability(BranchGroup.ALLOW_CHILDREN_READ);
    this.setCapability(BranchGroup.ALLOW_CHILDREN_WRITE);
    this.setCapability(BranchGroup.ALLOW_CHILDREN_EXTEND);
    this.setCapability(BranchGroup.ALLOW_DETACH);
    this.setCapability(BranchGroup.ENABLE_PICK_REPORTING);
  }

  void restore3D(){
    sinit3D();
    init3D();
  }

  abstract void init3D();

  abstract void step();//any phenomenon should specify what to do each time step...

  public void destroy(){
    this.detach();
    try{
      this.finalize();
    }catch (Throwable th){
      System.out.println(th.getMessage());
    }
  }


}