
/**
 * Title:        "Knowledge Emerging from Behaviour" Architecture<p>
 * Description:  <p>
 * Copyright:    Copyright (c) Carlos Gershenson, C.Gershenson@sussex.ac.uk<p>
 * Company:      COGS, University of Sussex<p>
 * @author Carlos Gershenson, C.Gershenson@sussex.ac.uk
 * @version 3.0
 */
package keba;

import javax.media.j3d.*;
import javax.vecmath.*;
import com.sun.j3d.utils.geometry.*;
import keba.tools.*;
import java.awt.Color;

public class Rain extends Phenomenon {

  public Rain(float nz, float nx, float nradius,long nid) {
    //z x radius colour flavourp flavourn odourp odourn hardness loudness id type
    super(nz,nx,nradius,new Color(0.1f, 0.2f, 0.4f),0.3f,0.0f,0.3f,0.0f,0.001f,0.5f,
          nid, KEBA.RAIN);
    init3D();
  }

  void init3D(){
    int height = 100;
    t=new STransform3D();
    t.setTranslation(new Vector3f(x,1+height/2,z));
    tg.setTransform(t);
    Appearance app=new Appearance();
    Color3f aColor    = new Color3f(0.3f, 0.3f, 0.3f);
    Color3f eColor    = new Color3f(0.3f, 0.3f, 0.4f);
    Color3f dColor    = new Color3f(colour);
    Color3f sColor    = new Color3f(0.2f, 0.2f, 0.2f);
    Material mat = new Material(aColor, eColor, dColor, sColor, 100.0f);
    mat.setLightingEnable(true);
    app.setMaterial(mat);
    app.setTransparencyAttributes(
       new TransparencyAttributes(TransparencyAttributes.FASTEST, 0.4f));

    tg.addChild(new Cylinder(radius,height,Primitive.GENERATE_NORMALS
                           | Primitive.GENERATE_TEXTURE_COORDS,app));
  }

  void step() {
    time++;
    //sound?
    if (time>=50){//transform Rain into Food...
      KEBA.transform(this);
    }
  }
}