
/**
 * Title:        "Knowledge Emerging from Behaviour" Architecture<p>
 * Description:  <p>
 * Copyright:    Copyright (c) Carlos Gershenson, C.Gershenson@sussex.ac.uk<p>
 * Company:      COGS, University of Sussex<p>
 * @author Carlos Gershenson, C.Gershenson@sussex.ac.uk
 * @version 3.0
 */
package keba;

import javax.media.j3d.*;
import javax.vecmath.*;
import com.sun.j3d.utils.geometry.*;
import keba.tools.*;
import java.awt.Color;

public abstract class Spot extends Phenomenon {

  public Spot(float nz, float nx, float nradius, Color col, long nid, int type) {
    //z x radius colour flavourp flavourn odourp odourn hardness loudness id type
    super(nz,nx,nradius, col,0.0f,0.0f,0.0f,0.0f,0.55f,0.0f, nid, type);
    init3D();
  }

  void init3D(){
    float height = 0.3f;
    t=new STransform3D();
    t.setTranslation(new Vector3f(x,1+height/2,z));
    tg.setTransform(t);
    Appearance app=new Appearance();
    Color3f aColor    = new Color3f(colour);
    Color3f eColor    = new Color3f(colour);
    Color3f dColor    = new Color3f(colour);
    Color3f sColor    = new Color3f(0.6f, 0.6f, 0.6f);
    Material mat = new Material(aColor, eColor, dColor, sColor, 100.0f);
    mat.setLightingEnable(true);
    app.setMaterial(mat);
    app.setTransparencyAttributes(
       new TransparencyAttributes(TransparencyAttributes.FASTEST, 0.2f));

    tg.addChild(new Cylinder(radius,height,Primitive.GENERATE_NORMALS
                           | Primitive.GENERATE_TEXTURE_COORDS,app));
  }

  void step() {
    time++;
    if (time>=1000){//remove...
      KEBA.transform(this);
    }
  }
}