
/**
 * Title:        "Knowledge Emerging from Behaviour" Architecture<p>
 * Description:  <p>
 * Copyright:    Copyright (c) Carlos Gershenson, C.Gershenson@sussex.ac.uk<p>
 * Company:      COGS, University of Sussex<p>
 * @author Carlos Gershenson, C.Gershenson@sussex.ac.uk
 * @version 3.0
 */
package keba.tools;

import javax.media.j3d.*;
import com.sun.j3d.utils.image.*;

public class TexturedAppearance extends Appearance {
  static java.awt.Component observer;

  //Use this method once before constructing any textured appearances.
  public static void setImageObserver(java.awt.Component imageObserver){
      observer = imageObserver;
  }

  public TexturedAppearance(String file) {
    super();
    TexCoordGeneration TCG=new TexCoordGeneration();
    this.setTexCoordGeneration(TCG);

    try{
      TextureLoader loader = new TextureLoader(file, observer);
      ImageComponent2D image = loader.getImage();
      Texture2D texture = new Texture2D(Texture.BASE_LEVEL, Texture.RGBA,
                                        image.getWidth(), image.getHeight());
      texture.setImage(0, image);
      texture.setEnable(true);
      texture.setMagFilter(Texture.NICEST);
      this.setTexture(texture);
      TextureAttributes texAttr = new TextureAttributes();
      texAttr.setTextureMode(TextureAttributes.MODULATE);
      this.setTextureAttributes(texAttr);
      //this.setTransparencyAttributes(
      //     new TransparencyAttributes(TransparencyAttributes.FASTEST, 0.1f));
    }catch(Exception e){
      System.out.println(file+" could not be loaded!!!");
      System.out.println("  check README.txt");
    }
  }

}